/* wydawca - automatic release submission daemon
   Copyright (C) 2009-2011 Sergey Poznyakoff

   Wydawca is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3 of the License, or (at your
   option) any later version.

   Wydawca is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with wydawca. If not, see <http://www.gnu.org/licenses/>. */

#include "wydawca.h"

static struct txtacc *report_acc;
char *report_string;

void
report_init ()
{
  if (!report_acc)
    report_acc = txtacc_create ();
  else
    txtacc_free_string (report_acc, report_string);
}

void
report_add (const char *fmt, ...)
{
  va_list ap;
  char *str = NULL;
  size_t size = 0;
  
  va_start (ap, fmt);
  grecs_vasprintf (&str, &size, fmt, ap);
  va_end (ap);
  if (str)
    {
      txtacc_grow (report_acc, str, strlen (str));
      txtacc_1grow (report_acc, '\n');
    }
  free (str);
}

void
report_finish ()
{
  txtacc_1grow (report_acc, 0);
  report_string = txtacc_finish (report_acc, 0);
}
